using System.ServiceModel;

namespace DotNetSamples.Common.Contract
{
    /// <summary>
    /// Servicens kontrakt
    /// </summary>
    [ServiceContract(Namespace = "urn:dmp:brugerstyring:samples:1.0.0")]
    public interface IServiceContract
    {
        /// <summary>
        /// Hello world operation, der blot echo'er brugerens
        /// query
        /// </summary>
        [OperationContract]
        HelloWorldResult HelloWorld(HelloWorldQuery query);

        /// <summary>
        /// Operation, der checker at bootstrap token'et er tilgngeligt
        /// p service-siden ift. brugen af act as
        /// </summary>
        [OperationContract]
        void AssertBootstrapTokenIsAvailable();

        /// <summary>
        /// Operation, der laver et ActAs request efter et nyt token 
        /// baseret p det indgende token til servicen. Det nye token
        /// phftes et kald til Java servicen
        /// </summary>
        [OperationContract]
        JavaServiceResult CallJavaServiceWithActAs();
    }
}
