﻿using System.ServiceModel;
using DotNetSamples.Common;
using NUnit.Framework;

namespace DotNetSamples.Tests
{
    [TestFixture]
    public class JavaTests
    {
        [Test]
        public void TestCanCallJavaServiceWithTokenFromUserNameAuth()
        {
            // Hent security token
            var securityToken = WsTrustClient.RequestSecurityTokenWithUserName(
                Constants.StsAddressUserName,
                Constants.StsCertificate,
                Constants.JavaServiceAddress,
                Constants.DmpUserName,
                Constants.DmpPassword);

            // Verificer, at token'et returneres
            Assert.That(securityToken, Is.Not.Null);

            // Kald service
            var result = TestCommon.TestCanCallJavaServiceWithIssuedToken(securityToken);

            Assert.That(result, Is.Not.Null);
            Assert.That(result.Body, Is.Not.Null);
            //Assert.That(result.Body.@return, Is.StringMatching("Hello Java!"));
        }

        [Test]
        public void TestCanCallJavaServiceWithTokenFromX509Auth()
        {
            // Hent security token
            var securityToken = WsTrustClient.RequestSecurityTokenWithX509(
                Constants.StsAddressCertificate,
                Constants.StsCertificate,
                Constants.JavaServiceAddress,
                Constants.GetClientCertificateTest());

            // Verificer, at token'et returneres
            Assert.That(securityToken, Is.Not.Null);

            // Kald service
            var result = TestCommon.TestCanCallJavaServiceWithIssuedToken(securityToken);

            Assert.That(result, Is.Not.Null);
            Assert.That(result.Body, Is.Not.Null);
            Assert.That(result.Body, Is.StringMatching("Hello Java!"));
        }
    }
}
