﻿using System;
using System.Linq;
using System.Security.Claims;
using System.Threading;
using System.Web.UI;

namespace DotNetSamples.WebApp
{
    public partial class Default : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if(!IsPostBack)
            {
                // Hent claims identity
                var claimsIdentity = GetClaimsIdentity();

                // Sæt name label til SAML 1.1 uid claim'en
                NameLabel.Text = claimsIdentity.Claims.Single(
                    c => string.Equals(c.Type, "urn:oid/0.9.2342.19200300.100.1.1")).Value;

                // Populer repeater med alle claims
                ClaimsRepeater.DataSource = claimsIdentity.Claims;
                ClaimsRepeater.DataBind();
            }
        }

        /// <summary>
        /// Henter claims identity ud fra tråden
        /// </summary>
        private static ClaimsPrincipal GetClaimsIdentity()
        {
            var claimsPrincipal = Thread.CurrentPrincipal as ClaimsPrincipal;

            if(claimsPrincipal == null)
                throw new ApplicationException("ClaimsPrincipal must not be null");

            if(claimsPrincipal.Identities == null || claimsPrincipal.Identities.Count() < 1)
                throw new ApplicationException("ClaimsPrincipal must contain identities");

            return claimsPrincipal;
        }
    }
}